var toolbar = Vue.component('m2m-admin-toolbar', {
    template: `
        <v-toolbar dark class="mb-2" fixed app>
            <v-layout align-center>
                <span class="subheading">{{this.title}}</span>
                <v-spacer></v-spacer>
                <v-toolbar-items>
                    <!--<v-menu offset-y dark transition="slide-y-transition" left v-if="this.notifications.length > 0">
                        <v-btn flat icon slot="activator">
                            <v-badge left>
                                <span slot="badge">{{ this.notifications.length }}</span>
                                <v-icon>notifications</v-icon>
                            </v-badge>
                        </v-btn>
                        <v-list dense>
                            <v-list-tile v-for="(item, index) in notifications" :key="index" @click="">
                                <v-list-tile-action v-if="item.icon.length > 0">
                                    <v-icon>{{ item.icon }}</v-icon>
                                </v-list-tile-action>
                                <v-list-tile-content>
                                    <v-list-tile-title>{{ item.title }}</v-list-tile-title>
                                </v-list-tile-content>
                            </v-list-tile>
                        </v-list>
                    </v-menu>
                    <v-menu offset-y dark transition="slide-y-transition" left v-if="this.notifications.length == 0">
                        <v-btn flat icon slot="activator">
                            <v-icon>notifications_none</v-icon>
                        </v-btn>
                        <v-list dense>
                            <v-list-tile>
                                <v-list-tile-content>
                                    <v-list-tile-title>There are no new notifications!</v-list-tile-title>
                                </v-list-tile-content>
                            </v-list-tile>
                        </v-list>
                    </v-menu>-->
                    <v-menu offset-y dark transition="slide-y-transition" left>
                        <v-btn flat icon slot="activator">
                                <v-icon>account_circle</v-icon>
                        </v-btn>
                        <v-list dense>
                            <v-list-tile avatar>
                                <v-list-tile-avatar>
                                    <v-icon>account_circle</v-icon>
                                </v-list-tile-avatar>
                    
                            <v-list-tile-content>
                                <v-list-tile-title>{{ this.userfullname }}</v-list-tile-title>
                                <v-list-tile-sub-title class="caption">Last login: {{ this.formattedLastLogin }}</v-list-tile-sub-title>
                            </v-list-tile-content>
                    
                            </v-list-tile>                
                            <v-divider></v-divider>
                            <v-list-tile v-for="(item, index) in accountItems" :key="index" @click="userAction(item)">
                                <v-list-tile-action>
                                    <v-icon>{{ item.icon }}</v-icon>
                                </v-list-tile-action>
                                <v-list-tile-content>
                                    <v-list-tile-title>{{ item.title }}</v-list-tile-title>
                                </v-list-tile-content>
                            </v-list-tile>
                        </v-list>
                    </v-menu>
                    
                </v-toolbar-items>
            </v-layout>
        </v-toolbar>
`,
    props: ['cart', 'logo','userfullname','lastlogin'],
    data() {
        return {
            notifications: [
                { title: '10 new orders', icon: 'list' },
            ],
            accountItems: [
                { title: 'Logout', icon: 'exit_to_app' },
            ],
            title: '',
        }
    },
    created() {
        
    },
    computed: {
        formattedLastLogin: function() {
            let d = new Date(this.lastlogin),
                month = '' + (d.getMonth() + 1),
                day = '' + d.getDate(),
                year = d.getFullYear();

            if (month.length < 2) month = '0' + month;
            if (day.length < 2) day = '0' + day;

            return [month, day, year].join('/');
        },
    },
    mounted: function() {
        serverBus.$on('changePageTitle', (title) => {
            this.title = title;
        });
    },
    methods: {
        getCartItemQty: function() {
            let qty = 0;
            this.cart.forEach(item => {
                qty += parseInt(item.qty == null || item.qty == undefined || item.qty == '' ? 0 : item.qty);
            });

            return qty;
        },
        userAction: function(item) {
            if (item.title == 'Logout') {
                app.signOut();
                this.$router.push('/');
            }
        }
    }
})