<?php
$authorization_key = '';

GetRequestHeaders();
ProcessRequest();

// Get all product types available for the M2M Kiosk
function GetAllProductTypes( $apiUrl ) {
    global $authorization_key;
    $curl = curl_init();

    curl_setopt_array($curl, array(
    CURLOPT_URL => $apiUrl . "prodtype",
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => "",
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 30,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => "GET",
    CURLOPT_HTTPHEADER => array(
        "Cache-Control: no-cache",
        "Authorization: " . $authorization_key
    ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function GetModificationCategories( $apiUrl ) {
    global $authorization_key;

    $typeId = 0;
    if ( isset( $_GET['t'] ) )
        $typeId = intval( $_GET['t'] );

    $curl = curl_init();

    curl_setopt_array($curl, array(
        CURLOPT_URL => $apiUrl . "modcat/" . $typeId,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "GET",
        CURLOPT_HTTPHEADER => array(
            "Cache-Control: no-cache",
            "Authorization: " . $authorization_key
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function GetModificationOptions( $apiUrl ) {
    global $authorization_key;

    $modId = 0;
    if ( isset( $_GET['c'] ) )
        $modId = intval( $_GET['c'] );

    $curl = curl_init();

    curl_setopt_array($curl, array(
    CURLOPT_URL => $apiUrl . "modopt/" . $modId,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => "",
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 30,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => "GET",
    CURLOPT_HTTPHEADER => array(
        "Cache-Control: no-cache",
        "Authorization: " . $authorization_key
    ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function GetFabricCategories( $apiUrl ) {
    global $authorization_key;

    $typeId = 0;
    if ( isset( $_GET['t'] ) )
        $typeId = intval( $_GET['t'] );

    $curl = curl_init();

    curl_setopt_array($curl, array(
    CURLOPT_URL => $apiUrl . "fabcat/" . $typeId,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => "",
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 30,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => "GET",
    CURLOPT_HTTPHEADER => array(
        "Cache-Control: no-cache",
        "Authorization: " . $authorization_key
    ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function GetFabricOptions( $apiUrl ) {
    global $authorization_key;

    $fabCatId = 0;
    if ( isset( $_GET['c'] ) )
        $fabCatId = intval( $_GET['c'] );

    $prodId = 0;
    if ( isset( $_GET['pid'] ) )
        $prodId = intval( $_GET['pid'] );

    $curl = curl_init();

    curl_setopt_array($curl, array(
    CURLOPT_URL => $apiUrl . "fabmod/" . $fabCatId . '/' . $prodId,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => "",
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 30,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => "GET",
    CURLOPT_HTTPHEADER => array(
        "Cache-Control: no-cache",
        "Authorization: " . $authorization_key
    ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function GetSpecialCharges( $apiUrl ) {
    global $authorization_key;

    $curl = curl_init();

    curl_setopt_array($curl, array(
    CURLOPT_URL => $apiUrl . "specialcharges",
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => "",
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 30,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => "GET",
    CURLOPT_HTTPHEADER => array(
        "Cache-Control: no-cache",
        "Authorization: " . $authorization_key
    ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function CreateOrder( $apiUrl ) {
    global $authorization_key;

    $form = file_get_contents("php://input");
    if ( count( $form ) < 1 ) {
        echo "Missing form information.";
        exit;
    }

    $curl = curl_init();
    $curl_post_data['form'] = $form;
    curl_setopt_array($curl, array(
        CURLOPT_URL => $apiUrl . "order",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $curl_post_data,
        CURLOPT_HTTPHEADER => array(
            "Cache-Control: no-cache",
            "Authorization: " . $authorization_key
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function ProcessPayment( $apiUrl ) {
    global $authorization_key;

    $form = file_get_contents("php://input");
    if ( count( $form ) < 1 ) {
        echo "Missing form information.";
        exit;
    }

    $curl = curl_init();
    $curl_post_data['form'] = $form;
    curl_setopt_array($curl, array(
        CURLOPT_URL => $apiUrl . "regpayment",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $curl_post_data,
        CURLOPT_HTTPHEADER => array(
            "Cache-Control: no-cache",
            "Authorization: " . $authorization_key
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function ProcessPaymentNoAuth( $apiUrl ) {
    global $authorization_key;

    $form = file_get_contents("php://input");
    if ( count( $form ) < 1 ) {
        echo "Missing form information.";
        exit;
    }

    $curl = curl_init();
    $curl_post_data['form'] = $form;
    curl_setopt_array($curl, array(
        CURLOPT_URL => $apiUrl . "regpaymentnoauth",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $curl_post_data,
        CURLOPT_HTTPHEADER => array(
            "Cache-Control: no-cache",
            "Authorization: " . $authorization_key
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function GetOrderReceipt( $apiUrl ) {
    global $authorization_key;

    $orderId = 0;
    if ( isset( $_GET['oid'] ) )
        $orderId = intval( $_GET['oid'] );

    $curl = curl_init();

    curl_setopt_array($curl, array(
    CURLOPT_URL => $apiUrl . "orderreceipt/" . $orderId,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => "",
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 30,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => "GET",
    CURLOPT_HTTPHEADER => array(
        "Cache-Control: no-cache",
        "Authorization: " . $authorization_key
    ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
        exit;
    }

    $response = json_decode( $response, false );

    $image_path = [];
    // Construct PDF file
    require_once('tools/tcpdf_include.php');

    // // create new PDF document
    $pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);

    // set document information
    $pdf->SetCreator(PDF_CREATOR);
    $pdf->SetAuthor('Leonardo Fifth Avenue');
    $pdf->SetTitle('Order ' . $response->data->order->order_id . ' Receipt');
    $pdf->SetSubject('Order Receipt');
    $pdf->SetPrintHeader(false);
    $pdf->SetPrintFooter(false);

    $pdf->AddPage();

    $o_details = '';
    $o_summary = '';
    $p = '';
    $mods = [];
    $fabs = [];

    // For each customization of the product
    foreach( $response->data->order_detail as $item ) {
        if( $item->item_id != $p && $p != '' ) {
            $max_item = count($mods) > count($fabs) ? count($mods) : count($fabs);

            $tot_rows = 0;
            for( $i = 0; $i < $max_item; $i++ ) {

                
                $o_details .= '<tr><td>';
                if ( !empty( $mods[$i] ) ) {
                    $o_details .= '<table>
                                    <tr>
                                        <td rowspan="' . ($item->is_couture == 1 ? 3 : 2) . '" class="regular-image"><img src="' . str_replace( ".svg", ".jpg", $mods[$i]['image'] ) . '" alt="option image" class="item-opt-image" /></td>
                                        <td class="category">' . ucwords( str_replace( '-', ' ', $mods[$i]['category'] ) ) . '</td>
                                    </tr>
                                    <tr>
                                        <td class="regular-option">' . ucwords( str_replace( '-', ' ', $mods[$i]['option'] ) ) . '</td>
                                    </tr>';
                    if ( $item->is_couture == 1 ) {
                        $o_details .= '<tr>
                                        <td class="regular-option">' . $mods[$i]['couture_description'] . '<br></td>
                                       </tr>';
                    }
                    $o_details .= '</table>';
                }

                $o_details .= '</td><td>';
                if ( !empty( $fabs[$i] ) ) {
                    $o_details .= '<table>
                                    <tr>
                                        <td rowspan="2" class="regular-image"><img src="' . $fabs[$i]['image'] . '" alt="option image" class="item-opt-image" /></td>
                                        <td  class="category">' . ucwords( str_replace( '-', ' ', $fabs[$i]['category'] ) ) . '</td>
                                    </tr>
                                    <tr>
                                        <td  class="regular-option">' . ucwords( str_replace( '-', ' ', $fabs[$i]['option'] ) ) . '</td>
                                    </tr>
                                </table>';
                }

                $o_details .= '</td></tr>';
                $tot_rows = $i;
            }

            if ( $tot_rows < 3 ) {
                for( $i = 0; $i < 5; $i++ ) {
                    $o_details .= '<tr><td></td><td></td></tr>';
                }
            }

            $o_details .= '</table>';

            $mods = [];
            $fabs = [];
        }
        if ( $item->item_id != $p ) {
            $path = 'temp/' . $p . '.png';
            array_push( $image_path, $path );
            $im = new Imagick();
            $svg = $item->image;

            $im->readImageBlob($svg);
            $im->setImageFormat("png");
            $im->writeImage( $path );
            //<img src='data:image/svg+xml;base64," . $image . "' class='item-image'>
            $class = 'item-image';
            if( $item->product_name == 'Pant' )
                $class= 'item-image-pant';
            else if ( $item->product_name == 'Shirt' )
                $class= 'item-image-shirt';
            else if ( $item->product_name == 'Vest' )
                $class= 'item-image-vest';

            // If it is a couture item, do not include image
            if($item->is_couture == 1)
                $path = '';

            $o_details .= '<table class="item">
                            <tr><td></td><td></td><td></td></tr>
                            <tr>
                                <td rowspan="10"><img src="' . $path . '" class="' . $class . '"></td>
                                <td class="item-title">Design Attributes</td>
                                <td class="item-title">Fabrics</td>
                            </tr>';
            $p = $item->item_id;

            $im->clear();
            $im->destroy();
        }

        if( $item->customization_type == 'modification' ) {
            array_push( $mods, array( 'image' => $item->option_image, 'category' => $item->category_name, 'option' => $item->option_name, 'couture_description' => $item->couture_description ) );
        }
        if( $item->customization_type == 'fabric' ) {
            array_push( $fabs, array( 'image' => $item->option_image, 'category' => $item->category_name, 'option' => $item->option_name ) );
        }
    }

    $max_item = count($mods) > count($fabs) ? count($mods) : count($fabs);
    $tot_rows = 0;
    for( $i = 0; $i < $max_item; $i++ ) {

        $o_details .= '<tr><td>';
        if ( !empty( $mods[$i] ) ) {
            $o_details .= '<table>
                            <tr>
                                <td rowspan="' . ($item->is_couture == 1 ? 3 : 2) . '" class="regular-image"><img src="' . str_replace( ".svg", ".jpg", $mods[$i]['image'] ) . '" alt="option image" class="item-opt-image" /></td>
                                <td  class="category">' . ucwords( str_replace( '-', ' ', $mods[$i]['category'] ) ) . '</td>
                            </tr>
                            <tr>
                                <td  class="regular-option">' . ucwords( str_replace( '-', ' ', $mods[$i]['option'] ) ) . '</td>
                            </tr>';
            if ( $item->is_couture == 1 ) {
                $o_details .= '<tr>
                                <td class="regular-option">' . $mods[$i]['couture_description'] . '<br></td>
                               </tr>';
            }
            $o_details .= '</table>';
        }

        $o_details .= '</td><td>';
        if ( !empty( $fabs[$i] ) ) {
            $o_details .= '<table>
                            <tr>
                                <td rowspan="2" class="regular-image"><img src="' . $fabs[$i]['image'] . '" alt="option image" class="item-opt-image" /></td>
                                <td  class="category">' . ucwords( str_replace( '-', ' ', $fabs[$i]['category'] ) ) . '</td>
                            </tr>
                            <tr>
                                <td  class="regular-option">' . ucwords( str_replace( '-', ' ', $fabs[$i]['option'] ) ) . '</td>
                            </tr>
                        </table>';
        }

        $o_details .= '</td></tr>';
        $tot_rows = $i;
    }

    if ( $tot_rows < 3 ) {
        for( $i = 0; $i < 5; $i++ ) {
            $o_details .= '<tr><td></td><td></td></tr>';
        }
    }

    $o_details .= '</table>';
    // return $response->withJson(array('status' => 'true','data'=> $fabs[0]['category']), 200);

    // For each product in the order
    foreach( $response->data->order_summary as $item ) {
        $o_summary .= '<tr>
                        <td class="normal">' . $item->product_name . '</td>
                        <td class="normal-numeric">$' . $item->price . '</td>
                        <td class="normal-numeric">' . $item->qty . '</td>
                        <td class="normal-numeric">$' . $item->item_total . '</td>
                       </tr>';
    }

    // For each special charge
    foreach( $response->data->special_charges as $item ) {
        $o_summary .= '<tr>
                        <td class="normal">     Plus: ' . $item->name . '</td>
                        <td class="normal-numeric">$' . $item->amount . '</td>
                        <td class="normal-numeric">1</td>
                        <td class="normal-numeric">$' . $item->amount . '</td>
                       </tr>';
    }

    $html = '<style>
        .regular-image {
            font-size:10px;
            width: 30%;
        }
        .regular {
            font-size:9px;
            width: 70%;
        }
        .regular-option {
            font-size: 8px;
            width: 70%;
        }
        .category {
            font-size:9px;
            font-weight:600;
            width: 70%;
        }
        .normal {
            font-size: 10px;
        }
        .normal-numeric {
            font-size: 10px;
            text-align: right;
        }
        .logo {
            width: 20%;
        }
        .title {
            width: 60%;
            text-align:center;
            margin-top: 20px;
        }
        .order-caption {
            width: 20%;
            text-align: right;
            font-size: 8px;
        }
        .section {
            border-bottom: 1px solid #000;
        }
        .item-image {
            width: 120px;
            height: 150px;
        }
        .item-image-pant {
            width: 130px;
            height: 140px;
        }
        .item-image-shirt {
            width: 150px;
            height: 150px;
        }
        .item-image-vest {
            width: 130px;
            height: 120px;
        }
        .item-opt-image {
            width: 20px;
            height: 20px;
            border-radius: 50%;
        }
        .lowercase {
            text-transform: lowercase;
        }
        .uppercase {
            text-transform: uppercase;
        }
        .capitalize {
            text-transform: capitalize;
        }
        .summary-header {
            font-size:11px;
            border-bottom: 1px solid #000;
            width: 10%;
        }
        .summary-header-numeric {
            font-size:11px;
            border-bottom: 1px solid #000;
            width: 10%;
            text-align: right;
        }
        .summary-header-primary {
            font-size:11px;
            border-bottom: 1px solid #000;
            width: 70%;
        }
        .summary-footer {
            font-size:10px; 
            text-align: right;
        }
        .summary-footer-numeric { 
            font-size:10px;
            text-align: right;
        }
        .summary-footer-total {
            font-size:10px;
            text-align: right;
        }
        .summary-footer-balance {
            font-size:12px;
            text-align: right;
            color: green;
        }
        .paragraph {
            font-size: 8px;
        }
    </style>
    <table class="header">
        <tr>
            <td class="logo"><img src="tools/TCPDF/images/LFALogo.png" alt="LOGO" width="200" /></td>
            <td class="title"><h1>Made To Measure</h1></td>
            <td class="order-caption">
                <table>
                    <tr><td>Order #:</td><td>' . $response->data->order->order_id . '</td></tr>
                    <tr><td>Date: </td><td>' . DateTime::createFromFormat("Y-m-d H:i:s", $response->data->order->order_date)->format("m/d/Y") . '</td></tr>
                    <tr><td>Store: </td><td>' . $response->data->order->store_name . '</td></tr>
                    <tr><td>Rep: </td><td>' . $response->data->order->rep_code . '</td></tr>
                </table>
            </td>
        </tr>
    </table>
    <br><br>

    <h4 class="section uppercase">Order Items</h4>
    
   ' . $o_details . '
    
    <h4 class="section uppercase">Order Summary</h4>
    
    <table>
        <tr>
            <td class="normal">Customer Name:</td>
            <td class="normal" colspan="3">' . $response->data->order_summary[0]->customer_name . '</td>
        </tr>
        <tr>
            <td class="normal">Customer Phone:</td>
            <td class="normal" colspan="3">' . $response->data->order_summary[0]->customer_phone . '</td>
        </tr>
        <tr>
            <td class="normal">Customer Email:</td>
            <td class="normal" colspan="3">' . $response->data->order_summary[0]->customer_email . '</td>
        </tr>
        <tr>
            <td class="normal">Customer Address:</td>
            <td class="normal" colspan="3">' . $response->data->order->customer_address_line1 . '<br>' . 
                                            ($response->data->order->customer_address_line2 != null ? $response->data->order->customer_address_line2 . '<br>' : '') . 
                                            $response->data->order->customer_city . ' ' . $response->data->order->customer_state . ', ' . 
                                            $response->data->order->customer_zipcode . '</td>
        </tr>
        <tr><td></td><td></td><td></td><td></td></tr>
        <tr>
            <td class="summary-header-primary">Item</td>
            <td class="summary-header-numeric">Price</td>
            <td class="summary-header-numeric">Qty</td>
            <td class="summary-header-numeric">Total</td>
        </tr>
        <tr><td></td><td></td><td></td><td></td></tr>
        ' . $o_summary . '
        <tr><td></td><td></td><td></td><td></td></tr>
        <tr>
            <td class="summary-footer" colspan="3">Subtotal</td>
            <td class="summary-footer-numeric">$' . $response->data->order_summary[0]->subtotal . '</td>
        </tr>
        <tr>
            <td class="summary-footer" colspan="3">Discount</td>
            <td class="summary-footer-numeric">- $' . $response->data->order_summary[0]->discount_amount . '</td>
        </tr>
        <tr>
            <td class="summary-footer" colspan="3">Coupons [' . $response->data->order_summary[0]->coupon_code . ']</td>
            <td class="summary-footer-numeric">- $' . $response->data->order_summary[0]->coupon_amount_used . '</td>
        </tr>
        <tr>
            <td class="summary-footer" colspan="3">Tax</td>
            <td class="summary-footer-numeric">$' . $response->data->order_summary[0]->tax . '</td>
        </tr>
        <tr>
            <td class="summary-footer" colspan="3">Total</td>
            <td class="summary-footer-total">$' . $response->data->order_summary[0]->order_total . '</td>
        </tr>
        <tr><td></td><td></td><td></td><td></td></tr>
        <tr>
            <td class="summary-footer" colspan="3">Initial deposit</td>
            <td class="summary-footer-total">- $' . $response->data->order_summary[0]->order_payment . '</td>
        </tr>
        <tr><td></td><td></td><td></td><td></td></tr>
        <tr>
            <td class="summary-footer" colspan="3">Balance</td>
            <td class="summary-footer-balance">$' . $response->data->order_summary[0]->order_balance . '</td>
        </tr>
    </table>';        

    $pdf->writeHTML($html, true, false, true, false, '');
   
    // Add Page for terms and conditions
    $pdf->AddPage();
    $html = '<style>
                .paragraph {
                    font-size: 8px;
                }
                .paragraph-center {
                    font-size: 8px;
                    text-align: center;
                }
                .terms-header {
                    text-align: center;
                }
                .indent {
                    width: 5%;
                }
                .text {
                    width: 95%;
                }
                .border-top {
                    font-size: 8px;
                    border-top: 1px solid #000;
                    text-align: center;
                }
            </style>
            <h4 class="terms-header">LEONARDO FIFTH AVENUE CUSTOM SUIT/ TUXEDO ORDERS</h4>
             <p class="paragraph">Orders placed with Leonardo’s will be designed based on requirements (style, color, fabric and measurements) outlined by this completed form. After confirmation of order and deposit payment, any requested changes to the suit or tuxedo design, color or fabric are at the liability of the client. All orders and styles are final as soon as the payment is received and order is placed.</p>
             <p class="paragraph">Deposit <br>A 50% non-refundable deposit is required at time of ordering at stores. No order is considered final-firm nor processed unless a deposit is received by Leonardo’s. No work will be started until the deposit has been received. If deposit is not received in a timely manner, Leonardo’s can’t guarantee that you will get your order on time.</p>
             <p class="paragraph">Final Payment <br>The balance is due upon delivery at the stores or before your order is to be shipped, for online orders. For on-line orders, orders are never shipped out before final payment is received. Final payment for online orders should be made 14 days prior to the delivery. Delaying the final payment only delays the date the suit will get to you.</p>
             <p class="paragraph">Methods of Payment <br>Cash or Credit cards accepted at store level or on-line, including PayPal if available. No personal checks will be accepted.</p>
             <p class="paragraph">Shipping <br>The client takes full responsibility for shipping. When we have your address we will quote you the shipping and handling charges for all on-line orders. Shipping and handling charges will apply should you decide to have it shipped. If the suit, suits or products aren’t received in time or lost by courier company, Leonardo’s is not responsible for replacement or replacement value of the suit(s) or product. It is recommended that clients purchase extra shipping insurance for their shipping orders; and do all payments in advanced to prevent any delays in shipping. Opting out of such insurance is the complete responsibility of the client.</p>
             <br>
             <table><tr><td class="indent"></td><td class="text"><p class="paragraph">Express or Overnight Shipping - If you wait until 14 days before your requested delivery date to make your final payment, the shipping costs will increase. Orders shipped using FedEx express or overnight will be subject to a minimum fee of $75.00, which increases depending on where you live. This does not apply for customers which will pick up at stores.</p></td></tr></table>
             <br><br>
             <table><tr><td class="indent"></td><td class="text"><p class="paragraph">Shipping out of USA/ Puerto Rico - Order to the International destinations, other than USA or Puerto Rico, could be subject to duty and taxes at customs and are the client’s responsibility.</p></td></tr></table>
             <br><br>
             <table><tr><td class="indent"></td><td class="text"><p class="paragraph">Shipping to Leonardo Fifth Avenue - If the suit / suits / products aren’t received in time or lost by courier company, Leonardo Fifth Avenue is in no way responsible for replacement or replacement value of the suit(s) or product. It is recommended that clients purchase extra shipping insurance for their shipping orders. Opting out of such insurance is the complete responsibility of the client.</p></td></tr></table>
             <p class="paragraph">Return Policy <br>Absolutely no returns, no refunds, no exchanges or credits – NO EXCEPTIONS.</p>
             <p class="paragraph">Client Order Cancellation- In the event that a client has cancelled an order because they have decided not to participate on the event/wedding or can’t wear it due to an event cancelation, accident, family issue or health reason, the client is still liable for the full cost of their custom order as outlined in this form.</p>
             <p class="paragraph">Designer Order Cancellation- In the event that Leonardo Fifth Avenue has to cancel the order at any time, the client will receive only the deposit back. Leonardo’s is not responsible for replacement or replacement value of the suit(s) or product.</p>
             <p class="paragraph">Measurements <br>Your suit / suits are made to measure according to the measurements given by the client and outlined in this form, if order is placed on-line. When preparing for an event or wedding, clients may experience weight loss, therefore Leonardo Fifth Avenue cannot guarantee your custom suit will fit you. To avoid issues with body measurements, please keep Leonardo Fifth Avenue up to date with weight loss and send any updates to the measurement chart 45 days prior to the event. This will help us to ensure a perfect fit for your suit. Upon store pickup or receiving your suit, try it on immediately to ensure proper fit.</p>
             <p class="paragraph">Caring for your Suit <br>Leonardo’s is not responsible for the durability of the fabric or laundering of the suits. Our recommended washing treatment for all our products is to Professionally Dry-clean only.</p>
             <p class="paragraph">I have read and accept the terms and conditions of this sale. <br><br><br></p>
             
             <table>
                <tr>
                    <td class="border-top">CUSTOMER NAME IN PRINT</td>
                    <td></td>
                    <td class="border-top">DATE</td>
                </tr>
                <tr>
                    <td></td><td></td><td></td>
                </tr>
                <tr>
                    <td></td><td></td><td></td>
                </tr>
                <tr>
                    <td class="border-top">CUSTOMER SIGNATURE</td>
                    <td></td>
                    <td></td>
                </tr>
             </table>
             <p class="paragraph-center">CONTACT US<br>Website: www.leonardofifthavenue.com | Email: custom@leonardofifthavenue.com<br>Phone Number: 787-724-1085</p>';
    $pdf->writeHTML($html, true, false, true, false, '');


    // Close and output PDF document
    // This method has several options, check the source code documentation for more information.
    $pdf->Output('LFA_-_Made_To_Measure_Order_' . $response->data->order->order_id . '.pdf', 'D');
    for( $i = 0; $i < count( $image_path ); $i++ ) {
        unlink( $image_path[$i] );
    }
}

function GetFabricOrder( $apiUrl ) {
    global $authorization_key;

    $orderId = 0;
    $comment = '';
    if ( isset( $_GET['oid'] ) )
        $orderId = intval( $_GET['oid'] );
    if ( isset( $_GET['msg'] ) )
        $comment = $_GET['msg'];

    $curl = curl_init();

    curl_setopt_array($curl, array(
    CURLOPT_URL => $apiUrl . "forder/" . $orderId,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => "",
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 30,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => "GET",
    CURLOPT_HTTPHEADER => array(
        "Cache-Control: no-cache",
        "Authorization: " . $authorization_key
    ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
        exit;
    }

    $response = json_decode( $response, false );

    $image_path = [];
    // Construct PDF file
    require_once('tools/tcpdf_include.php');

    // // create new PDF document
    $pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);

    // set document information
    $pdf->SetCreator(PDF_CREATOR);
    $pdf->SetAuthor('Leonardo Fifth Avenue');
    $pdf->SetTitle('Order ' . $response->data->order->order_id);
    $pdf->SetSubject('Order');
    $pdf->SetPrintHeader(false);
    $pdf->SetPrintFooter(false);

    $pdf->AddPage();

    $o_details = '';
    $o_summary = '';
    $p = '';
    $mods = [];
    $fabs = [];

    // For each customization of the product
    foreach( $response->data->order_detail as $item ) {
        if( $item->item_id != $p && $p != '' ) {
            $max_item = count($mods) > count($fabs) ? count($mods) : count($fabs);

            $tot_rows = 0;
            for( $i = 0; $i < $max_item; $i++ ) {

                
                $o_details .= '<tr><td>';
                if ( !empty( $mods[$i] ) ) {
                    $o_details .= '<table>
                                    <tr>
                                        <td rowspan="' . ($item->is_couture == 1 ? 3 : 2) . '" class="regular-image"><img src="' . str_replace( ".svg", ".jpg", $mods[$i]['image'] ) . '" alt="option image" class="item-opt-image" /></td>
                                        <td class="category">' . ucwords( str_replace( '-', ' ', $mods[$i]['category'] ) ) . '</td>
                                    </tr>
                                    <tr>
                                        <td class="regular-option">' . ucwords( str_replace( '-', ' ', $mods[$i]['option'] ) ) . '</td>
                                    </tr>';
                    if ( $item->is_couture == 1 ) {
                        $o_details .= '<tr>
                                        <td class="regular-option">' . $mods[$i]['couture_description'] . '<br></td>
                                       </tr>';
                    }
                    $o_details .= '</table>';
                }

                $o_details .= '</td><td>';
                if ( !empty( $fabs[$i] ) ) {
                    $o_details .= '<table>
                                    <tr>
                                        <td rowspan="2" class="regular-image"><img src="' . $fabs[$i]['image'] . '" alt="option image" class="item-opt-image" /></td>
                                        <td  class="category">' . ucwords( str_replace( '-', ' ', $fabs[$i]['category'] ) ) . '</td>
                                    </tr>
                                    <tr>
                                        <td  class="regular-option">' . ucwords( str_replace( '-', ' ', $fabs[$i]['option'] ) ) . '</td>
                                    </tr>
                                </table>';
                }

                $o_details .= '</td></tr>';
                $tot_rows = $i;
            }

            if ( $tot_rows < 3 ) {
                for( $i = 0; $i < 5; $i++ ) {
                    $o_details .= '<tr><td></td><td></td></tr>';
                }
            }

            $o_details .= '</table>';

            $mods = [];
            $fabs = [];
        }
        if ( $item->item_id != $p ) {
            $path = 'temp/' . $p . '.png';
            array_push( $image_path, $path );
            $im = new Imagick();
            $svg = $item->image;

            $im->readImageBlob($svg);
            $im->setImageFormat("png");
            $im->writeImage( $path );
            //<img src='data:image/svg+xml;base64," . $image . "' class='item-image'>
            $class = 'item-image';
            if( $item->product_name == 'Pant' )
                $class= 'item-image-pant';
            else if ( $item->product_name == 'Shirt' )
                $class= 'item-image-shirt';
            else if ( $item->product_name == 'Vest' )
                $class= 'item-image-vest';

            // If it is a couture item, do not include image
            // if($item->is_couture == 1)
            //     $path = '';

            $o_details .= '<table class="item">
                            <tr><td></td><td></td><td></td></tr>
                            <tr>
                                <td rowspan="10"><img src="' . $path . '" class="' . $class . '"></td>
                                <td class="item-title">Design Attributes</td>
                                <td class="item-title">Fabrics</td>
                            </tr>';
            $p = $item->item_id;

            $im->clear();
            $im->destroy();
        }

        if( $item->customization_type == 'modification' ) {
            array_push( $mods, array( 'image' => $item->option_image, 'category' => $item->category_name, 'option' => $item->option_name, 'couture_description' => $item->couture_description ) );
        }
        if( $item->customization_type == 'fabric' ) {
            array_push( $fabs, array( 'image' => $item->option_image, 'category' => $item->category_name, 'option' => $item->option_name ) );
        }
    }

    $max_item = count($mods) > count($fabs) ? count($mods) : count($fabs);
    $tot_rows = 0;
    for( $i = 0; $i < $max_item; $i++ ) {

        $o_details .= '<tr><td>';
        if ( !empty( $mods[$i] ) ) {
            $o_details .= '<table>
                            <tr>
                                <td rowspan="' . ($item->is_couture == 1 ? 3 : 2) . '" class="regular-image"><img src="' . str_replace( ".svg", ".jpg", $mods[$i]['image'] ) . '" alt="option image" class="item-opt-image" /></td>
                                <td  class="category">' . ucwords( str_replace( '-', ' ', $mods[$i]['category'] ) ) . '</td>
                            </tr>
                            <tr>
                                <td  class="regular-option">' . ucwords( str_replace( '-', ' ', $mods[$i]['option'] ) ) . '</td>
                            </tr>';
            if ( $item->is_couture == 1 ) {
                $o_details .= '<tr>
                                <td class="regular-option">' . $mods[$i]['couture_description'] . '<br></td>
                               </tr>';
            }
            $o_details .= '</table>';
        }

        $o_details .= '</td><td>';
        if ( !empty( $fabs[$i] ) ) {
            $o_details .= '<table>
                            <tr>
                                <td rowspan="2" class="regular-image"><img src="' . $fabs[$i]['image'] . '" alt="option image" class="item-opt-image" /></td>
                                <td  class="category">' . ucwords( str_replace( '-', ' ', $fabs[$i]['category'] ) ) . '</td>
                            </tr>
                            <tr>
                                <td  class="regular-option">' . ucwords( str_replace( '-', ' ', $fabs[$i]['option'] ) ) . '</td>
                            </tr>
                        </table>';
        }

        $o_details .= '</td></tr>';
        $tot_rows = $i;
    }

    if ( $tot_rows < 3 ) {
        for( $i = 0; $i < 5; $i++ ) {
            $o_details .= '<tr><td></td><td></td></tr>';
        }
    }

    $o_details .= '</table>';
    
    $msg = '';
    if ( strlen($comment) > 0 ) {
        $msg = '<h4 class="section uppercase">Order Notes</h4>
            <p class="paragraph">' . $comment . '</p>';
    }

    $html = '<style>
        .regular-image {
            font-size:10px;
            width: 30%;
        }
        .regular {
            font-size:9px;
            width: 70%;
        }
        .regular-option {
            font-size: 8px;
            width: 70%;
        }
        .category {
            font-size:9px;
            font-weight:600;
            width: 70%;
        }
        .normal {
            font-size: 10px;
        }
        .normal-numeric {
            font-size: 10px;
            text-align: right;
        }
        .logo {
            width: 20%;
        }
        .title {
            width: 60%;
            text-align:center;
            margin-top: 20px;
        }
        .order-caption {
            width: 20%;
            text-align: right;
            font-size: 8px;
        }
        .section {
            border-bottom: 1px solid #000;
        }
        .item-image {
            width: 120px;
            height: 150px;
        }
        .item-image-pant {
            width: 130px;
            height: 140px;
        }
        .item-image-shirt {
            width: 150px;
            height: 150px;
        }
        .item-image-vest {
            width: 130px;
            height: 120px;
        }
        .item-opt-image {
            width: 20px;
            height: 20px;
            border-radius: 50%;
        }
        .lowercase {
            text-transform: lowercase;
        }
        .uppercase {
            text-transform: uppercase;
        }
        .capitalize {
            text-transform: capitalize;
        }
        .summary-header {
            font-size:11px;
            border-bottom: 1px solid #000;
            width: 10%;
        }
        .summary-header-numeric {
            font-size:11px;
            border-bottom: 1px solid #000;
            width: 10%;
            text-align: right;
        }
        .summary-header-primary {
            font-size:11px;
            border-bottom: 1px solid #000;
            width: 70%;
        }
        .summary-footer {
            font-size:10px; 
            text-align: right;
        }
        .summary-footer-numeric { 
            font-size:10px;
            text-align: right;
        }
        .summary-footer-total {
            font-size:10px;
            text-align: right;
        }
        .summary-footer-balance {
            font-size:12px;
            text-align: right;
            color: green;
        }
        .paragraph {
            font-size: 10px;
        }
    </style>
    <table class="header">
        <tr>
            <td class="logo"><img src="tools/TCPDF/images/LFALogo.png" alt="LOGO" width="200" /></td>
            <td class="title"><h1>Made To Measure</h1></td>
            <td class="order-caption">
                <table>
                    <tr><td>Order #:</td><td>' . $response->data->order->order_id . '</td></tr>
                    <tr><td>Date: </td><td>' . DateTime::createFromFormat("Y-m-d H:i:s", $response->data->order->order_date)->format("m/d/Y") . '</td></tr>
                </table>
            </td>
        </tr>
    </table>
    
    <h4 class="section uppercase">Order Items</h4>
    
    ' . $o_details . '
    
    <h4 class="section uppercase">Measurements</h4>

    <table>
        <tr><td></td><td></td><td></td><td></td></tr>
        <tr>
            <td>Height</td>
            <td>' . ($response->data->measurements->height_feet . '\' ' . $response->data->measurements->height_inch . '\'\'') . '</td>
            <td>Weight</td>
            <td>' . $response->data->measurements->weight . ' lbs</td>
        </tr>
        <tr>
            <td>Neck</td>
            <td>' . $response->data->measurements->neck . ' in</td>
            <td>Shoulder</td>
            <td>' . $response->data->measurements->shoulder . ' in</td>
        </tr>
        <tr>
            <td>Sleeve Length Left</td>
            <td>' . $response->data->measurements->sleeve_length . ' in</td>
            <td>Sleeve Length Right</td>
            <td>' . $response->data->measurements->sleeve_length_right . ' in</td>
        </tr>
        <tr>
            <td>Bicep</td>
            <td>' . $response->data->measurements->bicep . ' in</td>
            <td>Wrist</td>
            <td>' . $response->data->measurements->wrist . ' in</td>
        </tr>
        <tr>
            <td>Chest</td>
            <td>' . $response->data->measurements->chest . ' in</td>
            <td>Stomach</td>
            <td>' . $response->data->measurements->stomach . ' in</td>
        </tr>
        <tr>
            <td>Jacket Length Front</td>
            <td>' . $response->data->measurements->jacket_length_front . ' in</td>
            <td>Jacket Length Back</td>
            <td>' . $response->data->measurements->jacket_length_back . ' in</td>
        </tr>
        <tr>
            <td>Waist</td>
            <td>' . $response->data->measurements->waist . ' in</td>
            <td>Hips</td>
            <td>' . $response->data->measurements->hips . ' in</td>
        </tr>
        <tr>
            <td>Thigh</td>
            <td>' . $response->data->measurements->thigh . ' in</td>
            <td>Crotch</td>
            <td>' . $response->data->measurements->crotch . ' in</td>
        </tr>
        <tr>
            <td>knee</td>
            <td>' . $response->data->measurements->knee . ' in</td>
            <td>Leg Length</td>
            <td>' . $response->data->measurements->leg_length . ' in</td>
        </tr>
        <tr>
            <td>Vest Length Front</td>
            <td>' . $response->data->measurements->vest_length_front . ' in</td>
            <td>Vest Length Back</td>
            <td>' . $response->data->measurements->vest_length_back . ' in</td>
        </tr>
        <tr>
            <td>Cuff</td>
            <td>' . $response->data->measurements->cuff . ' in</td>
            <td>Watch Hand</td>
            <td>' . $response->data->measurements->watch_hand . '</td>
        </tr>
        <tr>
            <td>Calf</td>
            <td>' . $response->data->measurements->calf . ' in</td>
            <td>Coat Sleeve Left</td>
            <td>' . $response->data->measurements->coat_sleeve_left . ' in</td>
        </tr>
        <tr>
            <td>Coat Sleeve Right</td>
            <td>' . $response->data->measurements->coat_sleeve_right . ' in</td>
            <td></td>
            <td></td>
        </tr>
        <tr><td></td><td></td><td></td><td></td></tr>
    </table>

    <br>
    <h4 class="section uppercase">Customer Information</h4>
    <br>

    <table>
        <tr><td></td><td></td></tr>
        <tr>
            <td>Customer name: </td>
            <td>' . $response->data->order->customer_name . '</td>
        </tr>
    </table>' . $msg;        

    $pdf->writeHTML($html, true, false, true, false, '');

    // Close and output PDF document
    // This method has several options, check the source code documentation for more information.
    $pdf->Output('LFA_-_Made_To_Measure_Order_Request_' . $response->data->order->order_id . '.pdf', 'D');
    for( $i = 0; $i < count( $image_path ); $i++ ) {
        unlink( $image_path[$i] );
    }
}

function GetCuponDetails( $apiUrl ) {
    global $authorization_key;

    $couponCode = 0;
    if ( isset( $_GET['c'] ) )
        $couponCode = intval( $_GET['c'] );

    $curl = curl_init();

    curl_setopt_array($curl, array(
    CURLOPT_URL => $apiUrl . "coupon/" . $couponCode,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => "",
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 30,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => "GET",
    CURLOPT_HTTPHEADER => array(
        "Cache-Control: no-cache",
        "Authorization: " . $authorization_key
    ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function GetAdminOrderList( $apiUrl ) {
    global $authorization_key;

    $curl = curl_init();

    curl_setopt_array($curl, array(
    CURLOPT_URL => $apiUrl . "admin/orderlist",
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => "",
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 30,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => "GET",
    CURLOPT_HTTPHEADER => array(
        "Cache-Control: no-cache",
        "Authorization: " . $authorization_key
    ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function GetAdminOrderDetails( $apiUrl ) {
    global $authorization_key;

    $orderId = 0;
    if ( isset( $_GET['oid'] ) )
        $orderId = intval( $_GET['oid'] );

    $curl = curl_init();

    curl_setopt_array($curl, array(
    CURLOPT_URL => $apiUrl . "admin/orderdetails/" . $orderId,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => "",
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 30,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => "GET",
    CURLOPT_HTTPHEADER => array(
        "Cache-Control: no-cache",
        "Authorization: " . $authorization_key
    ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function ChangeOrderStatus( $apiUrl ) {
    global $authorization_key;

    $form = file_get_contents("php://input");
    if ( count( $form ) < 1 ) {
        echo "Missing form information.";
        exit;
    }

    $curl = curl_init();
    $curl_post_data['form'] = $form;
    curl_setopt_array($curl, array(
        CURLOPT_URL => $apiUrl . "admin/orderstatus",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $curl_post_data,
        CURLOPT_HTTPHEADER => array(
            "Cache-Control: no-cache",
            "Authorization: " . $authorization_key
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function CreateOrderNote( $apiUrl ) {
    global $authorization_key;

    $form = file_get_contents("php://input");
    if ( count( $form ) < 1 ) {
        echo "Missing form information.";
        exit;
    }

    $curl = curl_init();
    $curl_post_data['form'] = $form;
    curl_setopt_array($curl, array(
        CURLOPT_URL => $apiUrl . "admin/ordernote",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $curl_post_data,
        CURLOPT_HTTPHEADER => array(
            "Cache-Control: no-cache",
            "Authorization: " . $authorization_key
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function SaveOrderShipping( $apiUrl ) {
    global $authorization_key;

    $form = file_get_contents("php://input");
    if ( count( $form ) < 1 ) {
        echo "Missing form information.";
        exit;
    }

    $curl = curl_init();
    $curl_post_data['form'] = $form;
    curl_setopt_array($curl, array(
        CURLOPT_URL => $apiUrl . "admin/ordershipping",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $curl_post_data,
        CURLOPT_HTTPHEADER => array(
            "Cache-Control: no-cache",
            "Authorization: " . $authorization_key
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function SaveOrderMeasurements( $apiUrl ) {
    global $authorization_key;

    $form = file_get_contents("php://input");
    if ( count( $form ) < 1 ) {
        echo "Missing form information.";
        exit;
    }

    $curl = curl_init();
    $curl_post_data['form'] = $form;
    curl_setopt_array($curl, array(
        CURLOPT_URL => $apiUrl . "admin/ordermeasurements",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $curl_post_data,
        CURLOPT_HTTPHEADER => array(
            "Cache-Control: no-cache",
            "Authorization: " . $authorization_key
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function UpdateAttribute( $apiUrl ) {
    global $authorization_key;

    $form = file_get_contents("php://input");
    if ( count( $form ) < 1 ) {
        echo "Missing form information.";
        exit;
    }

    $curl = curl_init();
    $curl_post_data['form'] = $form;
    curl_setopt_array($curl, array(
        CURLOPT_URL => $apiUrl . "admin/updateattribute",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $curl_post_data,
        CURLOPT_HTTPHEADER => array(
            "Cache-Control: no-cache",
            "Authorization: " . $authorization_key
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function CreateNewUser ( $apiUrl ) {
    global $authorization_key;

    $form = file_get_contents("php://input");
    if ( count( $form ) < 1 ) {
        echo "Missing form information.";
        exit;
    }

    $curl = curl_init();
    $curl_post_data['form'] = $form;
    curl_setopt_array($curl, array(
        CURLOPT_URL => $apiUrl . "admin/newuser",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $curl_post_data,
        CURLOPT_HTTPHEADER => array(
            "Cache-Control: no-cache",
            "Authorization: " . $authorization_key
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function SignIn ( $apiUrl ) {
    global $authorization_key;

    $form = file_get_contents("php://input");
    if ( count( $form ) < 1 ) {
        echo "Missing form information.";
        exit;
    }

    $curl = curl_init();
    $curl_post_data['form'] = $form;
    curl_setopt_array($curl, array(
        CURLOPT_URL => $apiUrl . "signin",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $curl_post_data,
        CURLOPT_HTTPHEADER => array(
            "Cache-Control: no-cache",
            "Authorization: " . $authorization_key
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function ValidateStore( $apiUrl ) {
    global $authorization_key;

    $form = file_get_contents("php://input");
    if ( count( $form ) < 1 ) {
        echo "Missing form information.";
        exit;
    }

    $curl = curl_init();
    $curl_post_data['form'] = $form;
    curl_setopt_array($curl, array(
        CURLOPT_URL => $apiUrl . "valstr",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $curl_post_data,
        CURLOPT_HTTPHEADER => array(
            "Cache-Control: no-cache",
            "Authorization: " . $authorization_key
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function SignLCS( $apiUrl ) {
    global $authorization_key;

    $form = file_get_contents("php://input");
    if ( count( $form ) < 1 ) {
        echo "Missing form information.";
        exit;
    }

    $curl = curl_init();
    $curl_post_data['form'] = $form;
    curl_setopt_array($curl, array(
        CURLOPT_URL => $apiUrl . "signlcs",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $curl_post_data,
        CURLOPT_HTTPHEADER => array(
            "Cache-Control: no-cache",
            "Authorization: " . $authorization_key
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function CreateNewRepresentative( $apiUrl ) {
    global $authorization_key;

    $form = file_get_contents("php://input");
    if ( count( $form ) < 1 ) {
        echo "Missing form information.";
        exit;
    }

    $curl = curl_init();
    $curl_post_data['form'] = $form;
    curl_setopt_array($curl, array(
        CURLOPT_URL => $apiUrl . "admin/newrep",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $curl_post_data,
        CURLOPT_HTTPHEADER => array(
            "Cache-Control: no-cache",
            "Authorization: " . $authorization_key
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function CreateNewCoupon( $apiUrl ) {
    global $authorization_key;

    $form = file_get_contents("php://input");
    if ( count( $form ) < 1 ) {
        echo "Missing form information.";
        exit;
    }

    $curl = curl_init();
    $curl_post_data['form'] = $form;
    curl_setopt_array($curl, array(
        CURLOPT_URL => $apiUrl . "admin/newcoupon",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $curl_post_data,
        CURLOPT_HTTPHEADER => array(
            "Cache-Control: no-cache",
            "Authorization: " . $authorization_key
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function ToggleUser( $apiUrl ) {
    global $authorization_key;

    $form = file_get_contents("php://input");
    if ( count( $form ) < 1 ) {
        echo "Missing form information.";
        exit;
    }

    $curl = curl_init();
    $curl_post_data['form'] = $form;
    curl_setopt_array($curl, array(
        CURLOPT_URL => $apiUrl . "admin/toggleuser",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $curl_post_data,
        CURLOPT_HTTPHEADER => array(
            "Cache-Control: no-cache",
            "Authorization: " . $authorization_key
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function ToggleRepresentative( $apiUrl ) {
    global $authorization_key;

    $form = file_get_contents("php://input");
    if ( count( $form ) < 1 ) {
        echo "Missing form information.";
        exit;
    }

    $curl = curl_init();
    $curl_post_data['form'] = $form;
    curl_setopt_array($curl, array(
        CURLOPT_URL => $apiUrl . "admin/togglerep",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $curl_post_data,
        CURLOPT_HTTPHEADER => array(
            "Cache-Control: no-cache",
            "Authorization: " . $authorization_key
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function ToggleCoupon( $apiUrl ) {
    global $authorization_key;

    $form = file_get_contents("php://input");
    if ( count( $form ) < 1 ) {
        echo "Missing form information.";
        exit;
    }

    $curl = curl_init();
    $curl_post_data['form'] = $form;
    curl_setopt_array($curl, array(
        CURLOPT_URL => $apiUrl . "admin/togglecoupon",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $curl_post_data,
        CURLOPT_HTTPHEADER => array(
            "Cache-Control: no-cache",
            "Authorization: " . $authorization_key
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function ChangeUserPwd( $apiUrl ) {
    global $authorization_key;

    $form = file_get_contents("php://input");
    if ( count( $form ) < 1 ) {
        echo "Missing form information.";
        exit;
    }

    $curl = curl_init();
    $curl_post_data['form'] = $form;
    curl_setopt_array($curl, array(
        CURLOPT_URL => $apiUrl . "admin/changepwd",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $curl_post_data,
        CURLOPT_HTTPHEADER => array(
            "Cache-Control: no-cache",
            "Authorization: " . $authorization_key
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function GetRptJouralDate( $apiUrl ) {
    global $authorization_key;

    $date = '';
    if ( isset( $_GET['date'] ) )
        $date = $_GET['date'];

    $curl = curl_init();

    curl_setopt_array($curl, array(
    CURLOPT_URL => $apiUrl . "admin/rpt.journal/" . $date,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => "",
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 30,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => "GET",
    CURLOPT_HTTPHEADER => array(
        "Cache-Control: no-cache",
        "Authorization: " . $authorization_key
    ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function GetRptCuadreDate( $apiUrl ) {
    global $authorization_key;

    $date = '';
    if ( isset( $_GET['date'] ) )
        $date = $_GET['date'];

    $curl = curl_init();

    curl_setopt_array($curl, array(
    CURLOPT_URL => $apiUrl . "admin/rpt.cuadre/" . $date,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => "",
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 30,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => "GET",
    CURLOPT_HTTPHEADER => array(
        "Cache-Control: no-cache",
        "Authorization: " . $authorization_key
    ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function GetGeneric( $apiUrl ) {
    global $authorization_key;
    
    $action = '';
    if (isset($_GET['action']))
        $action = $_GET['action'];

    $curl = curl_init();

    curl_setopt_array($curl, array(
    CURLOPT_URL => $apiUrl . $action,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => "",
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 30,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => "GET",
    CURLOPT_HTTPHEADER => array(
        "Cache-Control: no-cache",
        "Authorization: " . $authorization_key
    ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo "cURL Error #:" . $err;
    } else {
        echo $response;
    }
}

function ProcessRequest() {
    // $apiUrl = "https://api.leonardofifthavenue.com/m2m/v1/"; // production
    $apiUrl = "http://dev.leonardofifthavenue.com/api/m2m/v1/index.php/"; // development
    $action = $_GET['action'];

    switch( $action ) {
        case 'prodtype':
            GetAllProductTypes( $apiUrl );
            break;
        case 'modcat':
            GetModificationCategories( $apiUrl );
            break;
        case 'modopt':
            GetModificationOptions( $apiUrl );
            break;
        case 'fabcat':
            GetFabricCategories( $apiUrl );
            break;
        case 'fabmod':
            GetFabricOptions( $apiUrl );
            break;
        case 'specialcharges':
            GetSpecialCharges( $apiUrl );
            break;
        case 'order':
            CreateOrder( $apiUrl );
            break;
        case 'receipt':
            GetOrderReceipt( $apiUrl );
            break;
        case 'forder':
            GetFabricOrder( $apiUrl );
            break;
        case 'coupon':
            GetCuponDetails( $apiUrl );
            break;
        case 'admin.orderlist':
            GetAdminOrderList( $apiUrl );
            break;
        case 'admin.orderdetails':
            GetAdminOrderDetails( $apiUrl );
            break;
        case 'admin.status':
            ChangeOrderStatus( $apiUrl );
            break;
        case 'admin.ordernote':
            CreateOrderNote( $apiUrl );
            break;
        case 'admin.ordershipping':
            SaveOrderShipping( $apiUrl );
            break;
        case 'admin.ordermeasurements':
            SaveOrderMeasurements( $apiUrl );
            break;
        case 'admin.updateattribute':
            UpdateAttribute( $apiUrl );
            break;
        case 'admin.newuser':
            CreateNewUser( $apiUrl );
            break;
        case 'admin.newrep':
            CreateNewRepresentative( $apiUrl );
            break;
        case 'admin.newcoupon':
            CreateNewCoupon( $apiUrl );
            break;
        case 'admin.toggleuser':
            ToggleUser( $apiUrl );
            break;
        case 'admin.togglerep':
            ToggleRepresentative( $apiUrl );
            break;
        case 'admin.togglecoupon':
            ToggleCoupon( $apiUrl );
            break;
        case 'admin.changepwd':
            ChangeUserPwd( $apiUrl );
            break;
        case 'admin.rpt.journal':
            GetRptJouralDate( $apiUrl );
            break;
        case 'admin.rpt.cuadre':
            GetRptCuadreDate( $apiUrl );
            break;
        case 'regpayment':
            ProcessPayment( $apiUrl );
            break;
        case 'regpaymentnoauth':
            ProcessPaymentNoAuth( $apiUrl );
            break;
        case 'signin':
            SignIn( $apiUrl );
            break;
        case 'valstr':
            ValidateStore( $apiUrl );
            break;
        case 'signlcs':
            SignLCS( $apiUrl );
            break;
        default:
            GetGeneric( $apiUrl );
            break;
    }
}

function GetRequestHeaders() 
{
    global $authorization_key;
    foreach($_SERVER as $name => $value)
    {
        if($name == 'HTTP_AUTHORIZATION')
        {
            $authorization_key = $value;
        }
    }
}