Vue.component('m2m-dialog', {
    template: `
        <div>
            <v-layout row justify-center style="position: fixed;bottom:0;left:0;">
                <v-dialog v-model="dialog" persistent max-width="290">
                    <v-btn color="green darken-1" slot="activator" dark fab bottom left><v-icon>refresh</v-icon></v-btn>
                    <v-card>
                        <v-card-title class="headline">Warning!</v-card-title>
                        <v-card-text>Are your sure you want to start again? You will loose everything in your cart.</v-card-text>
                        <v-card-actions>
                            <v-spacer></v-spacer>
                            <v-btn color="red darken-1" flat @click="restart()">Yes</v-btn>
                            <v-btn color="green darken-1" flat @click.native="dialog = false">No</v-btn>
                        </v-card-actions>
                    </v-card>
                </v-dialog>
                <m2m-addnew :settings="this.addMore" v-if="this.addMore.active"></m2m-addnew>
            </v-layout>
        </div>
`,
    props: ['s'],
    data() {
        return {
            dialog: false,
            addMore: null,
        }
    },
    created () {
        this.addMore = this.s;
    },
    methods: {
        restart: function () {
            let currentStore = app.store.store;
            app.store = {
                typeId: null,
                productId: null,
                productName: '',
                price: 0.00,
                qty: 0,
                modifications: [],
                fabrics: [],
                availableFabrics: [],
                createdFabrics: [],
                cart: [],
                coupon: {},
                discount: {
                    amount: 0,
                    note: ''
                },
                specialCharges: [],
                isEdit: false,
                editItemIndex: null,
                measurements: {

                },
                isLcsLogged: false,
                store: currentStore,
                savedCheckout: null,
            };

            this.dialog = false;
            router.push('/');
        }
    }
})