Vue.component('product-option', {
    props: ['type','pTypes'],
    template: `<v-flex xs3 :class="type.active || type.active == 1 ? 'active' : ''" @click="selectType()">
                <v-card>
                    <v-img class="white--text" height="500px" :src="type.img" contain>
                    </v-img>
                    <v-card-title>
                        <div>
                        <span class="grey--text display-1">{{ type.name }}</span><br>
                        <span>Design and personalize your item to match your style...</span>
                        </div>
                    </v-card-title>
                </v-card>
               </v-flex>`,
    methods: {
        selectType: function() {
            this.deactivateTypes();
            this.type.active = true;
            app.store.typeId = parseInt(this.type.type_id);

            switch(app.store.typeId) {
                case 1:
                    app.store.productId = 7644;
                    app.store.productName = 'Coat';
                    app.store.price = 550.00;
                    app.store.qty = 1;
                    break;
                case 2:
                    app.store.productId = 7717; //7637;
                    app.store.productName = 'Pant';
                    app.store.price = 249.00;
                    app.store.qty = 1;
                    break;
                case 3:
                    app.store.productId = 7701;
                    app.store.productName = 'Shirt';
                    app.store.price = 159.00;
                    app.store.qty = 1;
                    break;
                case 4:
                    app.store.productId = 7810;
                    app.store.productName = 'Vest';
                    app.store.price = 179.00;
                    app.store.qty = 1;
                    break;
            }

            serverBus.$emit('typeSelected', this.type);
        },
        deactivateTypes: function() {
            app.productTypes.forEach( function( item, index ) {
                item.active = false;
            });
        }
    }
});